      subroutine ci4xxx(fi1,fi2,fo1,fo2,vertex)
c
c This subroutine computes an amplitude of the 4-fermion
c coupling.
c
c input:
c       complex fi1(6)          : flow-in  fermion                   |fi>
c       complex fo1(6)          : flow-out fermion                   <fo|
c       complex fi2(6)          : flow-in  fermion                   |fi>
c       complex fo2(6)          : flow-out fermion                   <fo|
c
c output:
c       complex vertex         : amplitude                     <fo|fi><fo|fi>
c     
      implicit none
      double complex fi1(6),fo1(6),fi2(6),fo2(6),vertex(3)

      double precision rZero, rOne
      parameter( rZero = 0.0d0 )
      double complex cImag, cZero
      parameter( cImag = ( 0.0d0, 1.0d0 ), cZero = ( 0.0d0, 0.0d0 ) )


         vertex(1)=2*CImag*(fi1(2)*fi2(1) - fi1(1)*fi2(2))*
     -  (fo1(4)*fo2(3) - fo1(3)*fo2(4))

         vertex(2)=2*CImag*(fi1(1)*(fi2(3)*fo1(3) + fi2(4)*fo1(4))*
     -     fo2(1) + fi1(2)*
     -     (fi2(3)*fo1(3) + fi2(4)*fo1(4))*fo2(2) + 
     -    (fi2(1)*fo1(1) + fi2(2)*fo1(2))*
     -     (fi1(3)*fo2(3) + fi1(4)*fo2(4)))

         vertex(3)=2*CImag*(fi1(4)*fi2(3) - fi1(3)*fi2(4))*
     -  (fo1(2)*fo2(1) - fo1(1)*fo2(2))
c
      end
