!===============calculation of the color-correlated squraed born amplitudes==========
!====================================================================================
      subroutine dipoleCI22(p, results, ncol)
c return the color-correlated squared born amplitudes used in dipole subtraction
      implicit none
      double precision p(0:3, 4), results(3, 2, 0:1)
      double precision qq(2), qqx(4)
      double precision newcol1(4, 4), newcol2(4, 4)
      integer ncol, i, j, k
      common /tcor/ newcol1, newcol2
      include "calc.h"

      call calcSunF()

      if(ncol.eq.0) then

      newcol1=colvirt
      newcol2=colvirt

      elseif((ncol.eq.1).or.(ncol.eq.6)) then

      newcol1=0.d0
      newcol2=0.d0
      do i=1, 4
      do j=1, 4
      do k=1, 4
      newcol1(i, j)=newcol1(i, j)+colvirt(i, k)*colcor1(k, j)
      newcol2(i, j)=newcol2(i, j)+colvirt(i, k)*colcor3(k, j)
      enddo
      enddo
      enddo

      elseif((ncol.eq.2).or.(ncol.eq.5)) then

      newcol1=0.d0
      newcol2=0.d0
      do i=1, 4
      do j=1, 4
      do k=1, 4
      newcol1(i, j)=newcol1(i, j)+colvirt(i, k)*colcor2(k, j)
      newcol2(i, j)=newcol2(i, j)+colvirt(i, k)*colcor2(k, j)
      enddo
      enddo
      enddo

      elseif((ncol.eq.3).or.(ncol.eq.4)) then

      newcol1=0.d0
      newcol2=0.d0
      do i=1, 4
      do j=1, 4
      do k=1, 4
      newcol1(i, j)=newcol1(i, j)+colvirt(i, k)*colcor3(k, j)
      newcol2(i, j)=newcol2(i, j)+colvirt(i, k)*colcor1(k, j)
      enddo
      enddo
      enddo

      endif

      call qqborn(p, qq)
      call qqxborn(p, qqx)

      results=0.d0
      results(1, 1, 0)=qq(1)
      results(1, 2, 0)=qq(2)
      results(2, 1, 0)=qqx(1)
      results(2, 2, 0)=qqx(2)
      results(3, 1, 0)=qqx(3)
      results(3, 2, 0)=qqx(4)

      end subroutine


      subroutine qqborn(p,matrixsq)

c  2-2 squared matrix elements for u u -> u u
c  sumed over spin and colors and averaged over initial spin ,color
c  final state identical factor considered      

      implicit none
      double precision p(0:3,4)
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), i1(6), i2(6)
      double complex color(4, 0:6), coloraux(4, 0:6), vertex(3), vertex1
      double precision plus, minus, N, newcol1(4, 4), newcol2(4, 4)
      double precision gdot, t13, t24, t14, t23
      double precision matrixsq(2), averagefactor(2)
      integer i,j,ii,jj,nh1,nh2,nh3,nh4,nh5,ckey(3),ncol
      common /tcor/ newcol1, newcol2
      parameter (plus=1.d0)
      parameter (minus=-1.d0) 
      parameter (N=3.d0)
      external gdot
      include "calc.h"


      matrixsq=0.d0
      averagefactor(1)=1.d0/4.d0/9.d0
      averagefactor(2)=1.d0/8.d0/9.d0
      ckey=0
      do i=1, 3
      if((gs2(i).ne.0.d0).or.(go2(i).ne.0.d0)) then
      ckey(i)=1
      endif
      enddo

c helicity amplitudes calculation ! crossing here
      do nh1=-1, 1,2
      do nh2=-1, 1,2
      do nh3=-1, 1,2
      do nh4=-1, 1,2

      if(((ckey(1).ne.0).and.((nh1+nh2+nh3+nh4).eq.-4))
     -   .or.((ckey(3).ne.0).and.((nh1+nh2+nh3+nh4).eq.4))
     -   .or.((ckey(2).ne.0).and.((abs(nh1+nh2)+abs(nh3+nh4)).eq.0))) then

      color=(0.d0, 0.d0)

      call ixxxxx(p(0, 1), 0.d0, nh1, 1, f1)
      call ixxxxx(p(0, 2), 0.d0, nh2, 1, f2)
      call oxxxxx(p(0, 3), 0.d0, nh3, 1, f3)
      call oxxxxx(p(0, 4), 0.d0, nh4, 1, f4)
      t13=-2.d0*gdot(p(0, 1), p(0, 3))
      t14=-2.d0*gdot(p(0, 1), p(0, 4))

c QCD t-channel

      call ci4xxx(f1, f2, f3, f4, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t13
      vertex(2)=vertex(2)/2.d0
      color(2, 0)=color(2, 0)+vertex1
      do i=1, 3
      color(1, 1+2*(i-1))=color(1, 1+2*(i-1))+vertex(i)
      color(2, 2+2*(i-1))=color(2, 2+2*(i-1))+vertex(i)
      enddo
      
ccccccc

      coloraux=color


c QCD u-channel

      call ci4xxx(f1, f2, f4, f3, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t14
      vertex(2)=vertex(2)/2.d0
      color(4, 0)=color(4, 0)-vertex1
      do i=1, 3
      color(3, 1+2*(i-1))=color(3, 1+2*(i-1))-vertex(i)
      color(4, 2+2*(i-1))=color(4, 2+2*(i-1))-vertex(i)
      enddo
      
cccc
      do i=1, 4
      do j=0, 6
      do ii=1, 4
      do jj=0, 6
      if(zeronot1(j ,jj).ne.0) then 
      matrixsq(1)=matrixsq(1)+newcol1(i,ii)*coupl(j, jj)*
     -        dble(coloraux(i, j)*conjg(coloraux(ii, jj)))
      matrixsq(2)=matrixsq(2)+newcol1(i,ii)*coupl(j, jj)*
     -        dble(color(i, j)*conjg(color(ii, jj)))
      endif
      enddo
      enddo
      enddo
      enddo

      endif

      enddo
      enddo
      enddo
      enddo
c end of helicity calculations

      matrixsq(1)=averagefactor(1)*matrixsq(1)
      matrixsq(2)=averagefactor(2)*matrixsq(2)

      end subroutine


      subroutine qqxborn(p,matrixsq)

c  2-2 squared matrix elements for u ux -> u ux
c  sumed over spin and colors and averaged over initial spin ,color
c  final state identical factor considered      

      implicit none
      double precision p(0:3,4)
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), i1(6), i2(6)
      double complex color(4, 0:6), coloraux(4, 0:6), vertex(3), vertex1
      double precision plus, minus, N, newcol1(4, 4), newcol2(4, 4)
      double precision gdot, t13, t24, t14, t23
      double precision matrixsq(4), averagefactor(2)
      integer i,j,ii,jj,nh1,nh2,nh3,nh4,nh5,ckey(3),ncol
      common /tcor/ newcol1, newcol2
      parameter (plus=1.d0)
      parameter (minus=-1.d0) 
      parameter (N=3.d0)
      external gdot
      include "calc.h"


      matrixsq=0.d0
      averagefactor(1)=1.d0/4.d0/9.d0
      averagefactor(2)=1.d0/4.d0/9.d0
      ckey=0
      do i=1, 3
      if((gs2(i).ne.0.d0).or.(go2(i).ne.0.d0)) then
      ckey(i)=1
      endif
      enddo


c helicity amplitudes calculation ! crossing here
      do nh1=-1, 1,2
      do nh2=-1, 1,2
      do nh3=-1, 1,2
      do nh4=-1, 1,2

      if(((ckey(1).ne.0).and.((nh1-nh2+nh3-nh4).eq.-4))
     -   .or.((ckey(3).ne.0).and.((nh1-nh2+nh3-nh4).eq.4))
     -   .or.((ckey(2).ne.0).and.((abs(nh1-nh2)+abs(nh3-nh4)).eq.0))) then

      color=(0.d0, 0.d0)

      call ixxxxx(p(0, 1), 0.d0, nh1, 1, f1)
      call oxxxxx(p(0, 2), 0.d0, nh4, -1, f4)
      call oxxxxx(p(0, 3), 0.d0, nh3, 1, f3)
      call ixxxxx(p(0, 4), 0.d0, nh2, -1, f2)
      t13=-2.d0*gdot(p(0, 1), p(0, 3))
      t14=2.d0*gdot(p(0, 1), p(0, 2))

c QCD t-channel

      call ci4xxx(f1, f2, f3, f4, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t13
      vertex(2)=vertex(2)/2.d0
      color(2, 0)=color(2, 0)+vertex1
      do i=1, 3
      color(1, 1+2*(i-1))=color(1, 1+2*(i-1))+vertex(i)
      color(2, 2+2*(i-1))=color(2, 2+2*(i-1))+vertex(i)
      enddo
      
ccccccc

      coloraux=color


c QCD u-channel

      call ci4xxx(f1, f2, f4, f3, vertex)
      vertex1=(vertex(1)+vertex(2)+vertex(3))/t14
      vertex(2)=vertex(2)/2.d0
      color(4, 0)=color(4, 0)-vertex1
      do i=1, 3
      color(3, 1+2*(i-1))=color(3, 1+2*(i-1))-vertex(i)
      color(4, 2+2*(i-1))=color(4, 2+2*(i-1))-vertex(i)
      enddo
      
cccc
      do i=1, 4
      do j=0, 6
      do ii=1, 4
      do jj=0, 6
      if(zeronot1(j ,jj).ne.0) then 
      matrixsq(1)=matrixsq(1)+newcol2(i,ii)*coupl(j, jj)*
     -        dble(coloraux(i, j)*conjg(coloraux(ii, jj)))
      matrixsq(2)=matrixsq(2)+newcol2(i,ii)*coupl(j, jj)*
     -        (dble(color(i, j)*conjg(color(ii, jj)))+
     -      (5.d0-1.d0)*dble((color(i, j)-coloraux(i, j))*conjg
     -      ((color(ii, jj)-coloraux(ii, jj))))) 
      matrixsq(3)=matrixsq(3)+newcol2(i,ii)*coupl(j, jj)*
     -      (1.d0*dble((color(i, j)-coloraux(i, j))*conjg
     -      ((color(ii, jj)-coloraux(ii, jj))))) 
      matrixsq(4)=matrixsq(4)+newcol2(i,ii)*coupl(j, jj)*
     -        dble(color(i, j)*conjg(color(ii, jj)))
      endif
      enddo
      enddo
      enddo
      enddo

      endif

      enddo
      enddo
      enddo
      enddo
c end of helicity calculations

      matrixsq(1)=averagefactor(1)*matrixsq(1)
      matrixsq(2)=averagefactor(2)*matrixsq(2)
      matrixsq(3)=averagefactor(1)*matrixsq(3)
      matrixsq(4)=averagefactor(1)*matrixsq(4)

      end subroutine
